#ifndef _Verifier_thread_h
#define _Verifier_thread_h 1

#include <time.h>
#include <pthread.h>
#include <stddef.h>
#include <string.h>
#include <stdio.h>
#include <limits.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <unistd.h>
#include <fcntl.h> //for non_blocking socket
#include <errno.h>

#include "th_assert.h"
#include "Message_tags.h"
#include "ITimer.h"
#include "Request.h"
#include "Pre_prepare.h"
#include "Prepare.h"
#include "Commit.h"
#include "Checkpoint.h"
#include "New_key.h"
#include "Status.h"
#include "Fetch.h"
#include "Data.h"
#include "Meta_data.h"
#include "Meta_data_d.h"
#include "View_change.h"
#include "View_change_ack.h"
#include "New_view.h"
#include "Principal.h"
#include "Prepared_cert.h"
#include "Reply.h"
#include "K_max.h"
#include "Verifier_thread.h"
#include "Replica.h"





class Verifier_thread {

public:

  Verifier_thread(int port) {
    interval = 5;
    snd_buf_size = 4000000;
    rcv_buf_size = 4000000;
    no_check = 1;
    client_port = port;
    message="Verifier thread running!";
  }

  void *run(void);

   int client_socket; //read client request from there

private:
 
   int client_port;
   int interval;
   char* message;

   int server_socket; //write verified request through this

   Addr client_address;
   Addr server_address;
   Addr dest_address;

   int error;
   int snd_buf_size;
   int rcv_buf_size;
   int no_check;
   int ret;
   int size;

   struct timeval select_timeout;

   fd_set fdset;

   Message* m;

};

extern "C" void *Verifier_thread_startup(void *);

#endif //_Verifier_thread_h

